#pragma once
#include <string.h>
#include "audioeffectx.h"

// ============================================================================================
// MIDIp̒`
// ============================================================================================
#define MIDIMSG_MAXNUM 255

struct MidiMessage
{
	VstInt32 deltaFrames;  //MIDIbZ[W^C~O
	unsigned char message; //MIDIbZ[Wԍ
	unsigned char channel; //MIDI`l
	unsigned char data1;   //MIDIf[^1
	unsigned char data2;   //MIDIf[^2
};

class CMidiMsg
{
protected:
	int          cur;                 //ǂݍݒMIDÏʒu
	int          num;                 //󂯎MIDIbZ[W̐
	MidiMessage  buf[MIDIMSG_MAXNUM]; //󂯎MIDIbZ[Wۊǂobt@
public:
	CMidiMsg(void);
	~CMidiMsg(void);

	// obt@̃NAsB
	virtual void clearMidiMsg();

	// MIDIbZ[Wobt@ɒǉ
	// obt@ւ̒ǉ1As0Ԃ
	virtual int addMidiMsg(VstMidiEvent *midievent);
	virtual int addMidiMsg(MidiMessage msg);

	// obt@MIDIbZ[Wo
	virtual MidiMessage getMidiMsg();

	// obt@ɂMIDIbZ[W̐Ԃ
	virtual VstInt32 getMidiMessageNum();

	// obt@ŏɎoMIDIbZ[WDeltaFramesԂ
	virtual VstInt32 getNextDeltaFrames();

	// MIDIbZ[W𔻒fÃbZ[WɑΉ
	// onMidiKeyOn()֐AonMidiControlChange()֐ĂяoB
	// Ȃ̏ꍇAgetMidiMsg()gp̂ŒӁB
	virtual void midiProc(MidiMessage mididata);
	virtual void midiProc() { MidiMessage mididata = getMidiMsg(); midiProc(mididata); };

	// midiProc()֐ĂяoB
	// ꂼMIDIbZ[Wɉďs
	// ȉ6̓I[o[ChĎgƂ悢
	virtual void onMidiKeyOn  (unsigned char channel, unsigned char noteNo, unsigned char velo) {}; // ֐̒g͋
	virtual void onMidiKeyOff (unsigned char channel, unsigned char noteNo, unsigned char velo) {}; // ֐̒g͋
	virtual void onMidiProgramChange(unsigned char channel, unsigned char program) {};              // ֐̒g͋
	virtual void onMidiPoliKeyPress (unsigned char channel, unsigned char noteNo, unsigned char pressure) {}; // ֐̒g͋
	virtual void onMidiChannelPress (unsigned char channel, unsigned char pressure) {};             // ֐̒g͋
	virtual void onMidiPitchBend    (unsigned char channel, short pb) {};                           // ֐̒g͋
	// ȉ2͂܂I[o[ChĎgKv͂Ȃ
	virtual void onMidiSystemMessage(unsigned char systemmsg, unsigned char data1, unsigned char data2); // gCMidiMsg.cppɋL
	virtual void onMidiControlChange(unsigned char channel, unsigned char cc, unsigned char value);      // gCMidiMsg.cppɋL

	// onMidiSystemMessage()֐ĂяoB
	// VXebZ[Wɉď֐
	// I[o[ChĎgƂ悢
	// (AzXgAvP[VSystem Message邱Ƃ͂܂薳H)
	virtual void onMidiQuarterFrame(unsigned char data) {};
	virtual void onMidiSongPointer(short songpoint) {};
	virtual void onMidiSongSelect(unsigned char data) {};
	virtual void onMidiChainRequest() {};
	virtual void onMidiTimingClock() {};
	virtual void onMidiStart() {};
	virtual void onMidiContinue() {};
	virtual void onMidiStop(){};
	virtual void onMidiActiveSensing() {};
	virtual void onMidiSystemReset() {};

	// onMidiControlChange()֐ĂяoB
	// Rg[`FWbZ[Wɉď֐
	// I[o[ChĎgƂ悢
	virtual void onMidiCC000 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC001 (unsigned char channel, unsigned char value) {}; // ModulationDepth
	virtual void onMidiCC002 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC003 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC004 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC005 (unsigned char channel, unsigned char value) {}; // PortamentTime
	virtual void onMidiCC006 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC007 (unsigned char channel, unsigned char value) {}; // ChannelVolume
	virtual void onMidiCC008 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC009 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC010 (unsigned char channel, unsigned char value) {}; // Pan
	virtual void onMidiCC011 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC012 (unsigned char channel, unsigned char value) {}; // Expression
	virtual void onMidiCC013 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC014 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC015 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC016 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC017 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC018 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC019 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC020 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC021 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC022 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC023 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC024 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC025 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC026 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC027 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC028 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC029 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC030 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC031 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC032 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC033 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC034 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC035 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC036 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC037 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC038 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC039 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC040 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC041 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC042 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC043 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC044 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC045 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC046 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC047 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC048 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC049 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC050 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC051 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC052 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC053 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC054 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC055 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC056 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC057 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC058 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC059 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC060 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC061 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC062 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC063 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC064 (unsigned char channel, unsigned char value) {}; // DumperPedal
	virtual void onMidiCC065 (unsigned char channel, unsigned char value) {}; // PortamentOnOff
	virtual void onMidiCC066 (unsigned char channel, unsigned char value) {}; // SostenutoPedal
	virtual void onMidiCC067 (unsigned char channel, unsigned char value) {}; // SoftPedal
	virtual void onMidiCC068 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC069 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC070 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC071 (unsigned char channel, unsigned char value) {}; // Resonance
	virtual void onMidiCC072 (unsigned char channel, unsigned char value) {}; // ReleaseTime
	virtual void onMidiCC073 (unsigned char channel, unsigned char value) {}; // AttackTime
	virtual void onMidiCC074 (unsigned char channel, unsigned char value) {}; // Brightness
	virtual void onMidiCC075 (unsigned char channel, unsigned char value) {}; // DecayTime
	virtual void onMidiCC076 (unsigned char channel, unsigned char value) {}; // VibratoRate
	virtual void onMidiCC077 (unsigned char channel, unsigned char value) {}; // VibratoDepth
	virtual void onMidiCC078 (unsigned char channel, unsigned char value) {}; // VibratoDelay
	virtual void onMidiCC079 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC080 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC081 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC082 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC083 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC084 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC085 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC086 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC087 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC088 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC089 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC090 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC091 (unsigned char channel, unsigned char value) {}; // ReverbSend
	virtual void onMidiCC092 (unsigned char channel, unsigned char value) {}; // ChorusSend
	virtual void onMidiCC093 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC094 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC095 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC096 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC097 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC098 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC099 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC100 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC101 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC102 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC103 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC104 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC105 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC106 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC107 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC108 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC109 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC110 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC111 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC112 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC113 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC114 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC115 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC116 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC117 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC118 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC119 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC120 (unsigned char channel, unsigned char value) {}; // AllSoundOff
	virtual void onMidiCC121 (unsigned char channel, unsigned char value) {}; // AllControlReset
	virtual void onMidiCC122 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC123 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC124 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC125 (unsigned char channel, unsigned char value) {};
	virtual void onMidiCC126 (unsigned char channel, unsigned char value) {}; // MonoModeOnOff
	virtual void onMidiCC127 (unsigned char channel, unsigned char value) {}; // PoliModeOnOff
};
