#pragma once
#include <math.h>

#define VOICE_STATE_OFF 0
#define VOICE_STATE_ON  1

class CVoice
{
protected:
	float elapsedFrames; //IV[^n߂Ăo߂t[

	int   status; //IV[^̏ꍇTrue
	int   noteNo; //IV[^̉

	float sampleRate; //Tv[g(ftHg 44100)

public:
	inline CVoice(void);
	inline ~CVoice(void);

	// IV[^郁o[֐
	inline void init();

	// ݂̃IV[^̐UԂo[֐
	inline float amplitude();

	// IV[^̏ԂXV郁o[֐
	inline void  update();

	// IV[^̓JnE~郁o[֐
	inline void start(int note);
	inline void stop();

	// IV[^̃oϐݒ肷郁o[֐
	inline void setSampleRate(float newSampleRate);

	// IV[^̏Ԃ擾郁o[֐
	inline int  getStatus() { return status; };
	inline int  getNoteNo() { return noteNo; };

};

CVoice::CVoice()
{
	// {
	init();
}

CVoice::~CVoice()
{
}

void CVoice::init()
{
	// oϐ
	elapsedFrames = 0.0;
	status = VOICE_STATE_OFF;
	noteNo = 0;
	sampleRate =44100.0f;
}

float CVoice::amplitude()
{
	// IV[^̐UԂ
	if(status == VOICE_STATE_ON)
	{
		// IV[^̏ԂON̎
		float pi = 3.14159265f;

		// m[gNogvZ
		float freq = (float)(440.0 * pow(2.0, ((double)noteNo - 69.0)/12.0));;

		// ݂̐UʂԂ
		return (float)sin(2.0 * pi * freq * elapsedFrames / sampleRate);
	}
	else
	{
		// IV[^̏ԂOFF̎

		// 0Ԃ
		return 0.0f;
	}
}

void  CVoice::update()
{
	// oߎԂi߂
	elapsedFrames += 1.0f;
}

void CVoice::start(int note)
{
	status = VOICE_STATE_ON;
	noteNo = note;
}

void CVoice::stop()
{
	init();
}

void CVoice::setSampleRate(float newSampleRate)
{
	sampleRate = newSampleRate;
}